var AVAILABILITY_TOKEN = Math.floor(Math.random() * 212345);
var SCHEDULED_TOKEN = Math.floor(Math.random() * 212345);
var ACTION = 'Save';
var UPDATE_AVAILABILITY_ID = 0;
var UPDATE_SCHEDULED_ID = 0;
$(document).ready(function () {
    var table = $('#myTable').DataTable({
        responsive: false,
        "scrollX": true,
        "pageLength": 100,
        "order": [],
        "columns": [
            { "data": "factory_po_num" },
            { "data": "customer_po_num" },
            { "data": "customer_name" },
            { "data": "created_from" },
            { "data": "production_status" },
            { "data": "order_status" },
            { "data": "fund_status" },
            { "data": "shipping_status" },
            { "data": "vessel_status" },
            { "data": "action" },
            { "data": "status" },
            { "data": "edit" },
            // { "data": "view" },
            // { "data": "delete" },
            { "data": "view", className: "view" },
            { "data": "delete", className: "delete" },

        ],
        columnDefs: [
            { width: 100, targets: 0 },
            { width: 120, targets: 1 },
            { width: 25, targets: 4 },
            { width: 25, targets: 5 },
            { width: 25, targets: 6 },
            { width: 25, targets: 7 },
            { width: 100, targets: 8 },
            { width: 100, targets: 9 },
            { width: 25, targets: 10 },
            { width: 25, targets: 11 },
            { width: 25, targets: 12 },
            { width: 25, targets: 13 },
        ],
    });


    table.column(9).visible(false);
    table.column(10).visible(false);
    table.column(11).visible(false);
    table.column(13).visible(false);





    var max_year = (parseInt(serverDate().split('/')[0]) + 1);
    var min_year = (max_year - 5);
    for (var i = min_year; i <= max_year; i++) {

        $('#cmbYear').append('<option value="' + i + '">' + i + '</option>');
    }

    setSelectedOption('cmbYear', (max_year - 1));
    setSelectedOption('cmbMonth', parseInt(serverDate().split('/')[1]));



    allCustomerOrder($('#cmbYear').val(), $('#cmbMonth').val());


    $('#cmbYear').on('change', function () {
        var year = $(this).val();
        var month = $('#cmbMonth').val();
        getListFromYearMonth(year, month);
    });
    $('#cmbMonth').on('change', function () {
        var year = $('#cmbYear').val();
        var month = $(this).val();
        getListFromYearMonth(year, month);
    });


});








function allCustomerOrder(year, month) {
    $.ajax({
        type: "GET",
        url: "/sd/customerOrderList/allCustomerOrder/" + year + "/" + month,
        processData: false,
        contentType: false,
        cache: false,
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);
            if (response.data.success) {
                var data = [];
                var disable = { 0: "", 1: "checked" }
                for (i = 0; i < response.data.result.length; i++) {
                    var id = response.data.result[i]['order_id'];
                    var factory_po_num = response.data.result[i]['factory_po_num'];
                    var customer_po_num = response.data.result[i]['purchase_order'];
                    var customer_name = response.data.result[i]['customer_name'];
                    var created_from = response.data.result[i]['create_from'];
                    var production_status = response.data.result[i]['production_status'];
                    var shipping_status = response.data.result[i]['shipping_status'];
                    var order_status = response.data.result[i]['order_status'];
                    var fund_status = response.data.result[i]['fund_status'];
                    var string_id = "'" + id + "'";
                    var order_status_icon = '<span class="badge bg-primary text-primary-bright ">New</span>';
                    var edit_button = '<button class="btn btn-primary" onclick="edit(' + string_id + ')"><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>';
                    var delete_button = '<button class="btn btn-danger" onclick="_delete(' + string_id + ')"><i class="fa fa-trash" aria-hidden="true"></i></button>';
                    if (order_status == 0) {
                        order_status_icon = '<span class="badge bg-primary text-primary-bright ">New</span>';
                    } else if (order_status == 1) {
                        order_status_icon = '<span class="badge bg-success text-primary-bright ">Accepted</span>';
                        edit_button = '<button class="btn btn-primary" onclick="edit(' + string_id + ')" disabled><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>';
                        delete_button = '<button class="btn btn-danger" onclick="_delete(' + string_id + ')" disabled><i class="fa fa-trash" aria-hidden="true"></i></button>';
                    } else if (order_status == 2) {
                        order_status_icon = '<span class="badge bg-warning text-warning-bright ">Reviced</span>';
                    } else if (order_status == 3) {
                        order_status_icon = '<span class="badge bg-danger text-danger-bright ">Reject</span>';
                        edit_button = '<button class="btn btn-primary" onclick="edit(' + string_id + ')" disabled><i class="fa fa-pencil-square-o" aria-hidden="true"></i></button>';
                        delete_button = '<button class="btn btn-danger" onclick="_delete(' + string_id + ')" disabled><i class="fa fa-trash" aria-hidden="true"></i></button>';
                    } else if (order_status == 4) {
                        order_status_icon = '<span class="badge bg-info text-info-bright ">Proceeded</span>';
                    } else if (order_status == 5) {
                        order_status_icon = '<span class="badge bg-dark text-dark-bright ">Hold</span>';
                    }


                    var production_status_icon = '<span class="badge bg-primary text-primary-bright ">New</span>';
                    if (production_status == 0) {
                        production_status_icon = '<span class="badge bg-primary text-primary-bright ">New</span>';
                    } else if (production_status == 1) {
                        production_status_icon = '<span class="badge bg-success text-success-bright ">Planed</span>';
                    } else if (production_status == 2) {
                        production_status_icon = '<span class="badge bg-dark text-dark-bright ">Scheduled</span>';
                    } else if (production_status == 3) {
                        production_status_icon = '<span class="badge bg-warning text-warning-bright ">Start</span>';
                    } else if (production_status == 4) {
                        production_status_icon = '<span class="badge bg-danger text-danger-bright ">Hold</span>';
                    } else if (production_status == 5) {
                        production_status_icon = '<span class="badge bg-primary text-primary-bright ">Finished</span>';
                    } else if (production_status == 6) {
                        production_status_icon = '<span class="badge bg-success text-success-bright ">Delivered</span>';
                    }


                    var shipping_status_icon = '<span class="badge bg-primary text-primary-bright ">Shipping0</span>';
                    if (shipping_status == 0) {
                        shipping_status_icon = '<span class="badge bg-primary text-primary-bright ">Shipping1</span>';
                    } else if (shipping_status == 1) {
                        shipping_status_icon = '<span class="badge bg-success text-success-bright ">Shipping2</span>';
                    } else if (shipping_status == 2) {
                        shipping_status_icon = '<span class="badge bg-dark text-dark-bright ">Shipping3</span>';
                    } else if (shipping_status == 3) {
                        shipping_status_icon = '<span class="badge bg-warning text-warning-bright ">Shipping4</span>';
                    } else if (shipping_status == 4) {
                        shipping_status_icon = '<span class="badge bg-danger text-danger-bright ">Shipping5</span>';
                    } else if (shipping_status == 5) {
                        shipping_status_icon = '<span class="badge bg-primary text-primary-bright ">Shipping6</span>';
                    } else if (shipping_status == 6) {
                        shipping_status_icon = '<span class="badge bg-success text-success-bright ">Shipping7</span>';
                    }


                    var production_action_button = '<div class="dropdown">';
                    production_action_button += '<button type="button" class="btn btn-primary dropdown-toggle" data-toggle="dropdown">';
                    production_action_button += ' Action';
                    production_action_button += '</button>';
                    production_action_button += '<div class="dropdown-menu">';
                    production_action_button += '<a class="dropdown-item" href="#" onclick="shipping_status(' + string_id + ',' + 0 + ')">Status1</a>';
                    production_action_button += '<a class="dropdown-item" href="#" onclick="shipping_status(' + string_id + ',' + 1 + ')">Status2</a>';
                    production_action_button += '<a class="dropdown-item" href="#" onclick="shipping_status(' + string_id + ',' + 2 + ')">Status3</a>';
                    production_action_button += '<a class="dropdown-item" href="#" onclick="shipping_status(' + string_id + ',' + 3 + ')">Status4</a>';
                    production_action_button += '<a class="dropdown-item" href="#" onclick="shipping_status(' + string_id + ',' + 4 + ')">Status5</a>';
                    production_action_button += '<a class="dropdown-item" href="#" onclick="shipping_status(' + string_id + ',' + 5 + ')">Status6</a>';
                    production_action_button += '<a class="dropdown-item" href="#" onclick="shipping_status(' + string_id + ',' + 6 + ')">Status7</a>';
                    production_action_button += '</div></div>'


                    var vessel_action_button = '<div class="dropdown">';
                    vessel_action_button += '<button type="button" class="btn btn-primary dropdown-toggle" data-toggle="dropdown">';
                    vessel_action_button += ' Vessel';
                    vessel_action_button += '</button>';
                    vessel_action_button += '<div class="dropdown-menu">';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_availability(' + string_id + ',' + 0 + ')">Availability</a>';
                    vessel_action_button += '<a class="dropdown-item" href="#" onclick="vessel_scheduled(' + string_id + ',' + 1 + ')">Scheduled</a>';
                    vessel_action_button += '</div></div>'


                    var fund_status_icon = '<span class="badge bg-danger text-danger-bright ">No</span>';
                    if (fund_status == 0) {
                        fund_status_icon = '<span class="badge bg-danger text-danger-bright ">No</span>';
                    } else if (fund_status == 1) {
                        fund_status_icon = '<span class="badge bg-success text-success-bright ">Yes</span>';
                    }

                    data.push({
                        "factory_po_num": factory_po_num,
                        "customer_po_num": customer_po_num,
                        "customer_name": customer_name,
                        "created_from": created_from,
                        "production_status": production_status_icon,
                        "order_status": order_status_icon,
                        "fund_status": fund_status_icon,
                        "shipping_status": shipping_status_icon,
                        "vessel_status": vessel_action_button,
                        "action": production_action_button,
                        "status": '<label class="switch"><input type="checkbox" id="' + response.data.result[i].order_id + '" onchange="disable(event,' + "'Order'" + ')" ' + disable[response.data.result[i].status] + '><span class="slider round"></span</lable>',
                        "edit": edit_button,
                        "view": '<button class="btn btn-success" onclick="view(' + string_id + ')"><i class="fa fa-eye" aria-hidden="true"></i></button>',
                        "delete": delete_button,
                    });
                }

                //table
                var table = $('#myTable').DataTable();
                table.clear();
                table.rows.add(data).draw();

            } else {
                showErrorMessage();
            }

        },
        error: function (error) {
            console.log(error);

        },

    });
}


function view(id) {
    location.href = "/sd/customerOrder?id=" + id + "&action=view";
}








function getListFromYearMonth(year, month) {

    allCustomerOrder(year, month);
}


function setSelectedOption(id, valueToSelect) {
    let element = document.getElementById(id);
    element.value = valueToSelect;
}




function shipping_status(id, status) {

    swal({
        title: "Are you sure?",
        //text: "Once deleted, you will not be able to recover this record!",
        icon: "warning",
        buttons: {
            yes: {
                text: "Yes",
                value: true,
                className: 'btn btn-danger',
            },
            no: {
                text: "No",
                value: false,
                className: 'btn btn-primary',
            }
        },

    })
        .then((willDelete) => {
            if (willDelete) {
                do_shipping_status(id, status);
            }
        });
}




function do_shipping_status(id, status) {
    $.ajax({
        type: "POST",
        url: '/sd/customerOrderList/shipping_status',
        data: { 'id': id, 'status': status },
        headers: {
            'X-CSRF-TOKEN': $('meta[name="csrf-token"]').attr('content')
        },
        timeout: 800000,
        beforeSend: function () {

        },
        success: function (response) {
            console.log(response);

            if (response.data.success) {

                showSuccessMessage("Customer Order Shipping Status changed...");
                allCustomerOrder($('#cmbYear').val(), $('#cmbMonth').val());

            }

        },
        error: function (error) {
            console.log(error);
            showErrorMessage();

        },
        complete: function () {

        }

    });


}





function vessel_scheduled(id, status) {

    $('#scheduledModal').modal('show');
}







function checkStringLength(string, maxLength) {

    if (string.length > maxLength) {
        return false;
    }
    return true;

}








/**
* showSuccessMessage
* This function is used to show success message.
* @param message This is the paramter to require message content
*/
function showSuccessMessage(message) {
    toastr.success(message);
}


/**
* showWarningMessage
* This function is used to show warning message.
* @param message This is the paramter to require message content
*/
function showWarningMessage(message) {
    toastr.warning(message);
}



/**
* showErrorMessage
* This function is used to show error message.
* @param message This is the paramter to require message content
*/
function showErrorMessage(msg) {
    toastr.error(msg);
}